###############################################################################
# pedbot_block
#
# synopsis:  blocks the badman, adds the badman to blocked list hash, and adds
#            the badman to the blocked_users database table.
# arguments: badman.
# returns:   none.

sub pedbot_block {
    my $badman = shift;
    
    # in case it isn't already normalized lets due so.
    $badman = $aim->normalize($badman);
    
    pedbot_debug("blocking $badman");
    
    # if the user is already blocked then announce and return.
    #if ($blocked_users{$badman}) {
    #    pedbot_debug("$badman already blocked.");
    #    return;
    #}
    
    # block badman.
    $aim->add_deny(1, $C{GROUP_BLOCK}, $badman);
    
    # insert badman in memory hash.
    $blocked_users{$badman} = 1;
    
    # make sure badman doesn't already exist in database.
    my $sql_query = "SELECT COUNT(*) AS mycount FROM blocked_users WHERE "
                  . "screenname = '$badman'";
    
    my $dbquery = $dbhandle->prepare($sql_query);
       $dbquery->execute;
       
    my $result = $dbquery->fetchrow_hashref;
    
    return if ( $result->{mycount} );
    
    # insert badman into database.
    $sql_query = "INSERT INTO blocked_users SET screenname = '$badman'";
    
    $dbquery = $dbhandle->prepare($sql_query);
    $dbquery->execute;
    $dbquery->finish;
}1;